#BCX Breakdown Tool v1.00
#By Lazy Bastard of GameHacking.org

print('')

FO_BCX = open(raw_input('Enter the filename of the decompressed BCX: '), 'rb')

print('\n' + 'Parsing BCX data...')

#Creating a loop that iterates through the file one byte at a time for 8 bytes, and creates a list of bytes...
c=[]
for i in range(8):
	a=FO_BCX.read(1)
	b=a.encode("hex")
	c.append(b)

#Creating the file handle for the new breakdown...
FO_Breakdown = open('Breakdown.txt', 'wb')
	
#Saving the header to the new breakdown file...
FO_Breakdown.write('BCX Header Section [at offset 0x0000]:\n\n')
FO_Breakdown.write('[code]\n')

for i in c:
	FO_Breakdown.write(i + ' ')

FO_Breakdown.write('\n[/code]\n\n\n' + 'Breakdown:\n\n')

#Saving the file size, in decimal, for later
fileSize = int(c[0x1]+c[0x0], 16)
print('\n' + 'File size is:')
print(hex(fileSize))
print('')

#Creating list c anew, and placing the entirety of the file into the list, using the size of the file which we took from the header above...
c = []
FO_BCX.seek(0)
for i in range(fileSize):
	a=FO_BCX.read(1)
	b=a.encode("hex")
	c.append(b)

#Closing BCX file handle, since we don't need it anymore now that the entire file is in list c...
FO_BCX.close()

FO_Breakdown.write(c[0x0] + ' ' + c[0x1] + ' ' + c[0x2] + ' ' + c[0x3] + ' ' + '- size of the decompressed file in bytes. Little-endian, so 0x' + c[0x1] + c[0x0] + ', or in decimal, ' + str(fileSize) + '.\n\n')

FO_Breakdown.write(c[0x4] + ' ' + c[0x5] + ' ' + c[0x6] + ' ' + c[0x7] + ' ' + '- offset to Models Section. Little-endian, so 0x' + c[0x7] + c[0x6] + c[0x5] + c[0x4] + '.\n\n\n' + 'Note: BCX Header Section runs until Skeleton Data Section.\n\n\n' + '__________________________________________________\n\n\n')

FO_Breakdown.write('Skeleton Data Section [at offset 0x0008]:\n\n' + 'Note: Offset to Skeleton Data Section individual bones contained in Models Section, Parts.\n\n' + 'Note2: Number of parts contained in Models Section, Header.\n\n\n')

#Creating variables for the Models Section offset, number of bones, etc...
modelsSectionOffset = int((c[0x5] + c[0x4]), 16)
print('Models Section offset is:')
print(hex(modelsSectionOffset))

numberOfBones = int(c[(modelsSectionOffset + 2)], 16)
print('\n' + 'Number of bones is:')
print(hex(numberOfBones))

numberOfParts = int(c[(modelsSectionOffset + 3)], 16)
print('\n' + 'Number of parts is:')
print(hex(numberOfParts))

numberOfAnimations = int(c[(modelsSectionOffset + 4)], 16)
print('\n' + 'Number of animations is:')
print(hex(numberOfAnimations))

modelsSectionBonesOffset = int(c[(modelsSectionOffset + 29)] + c[(modelsSectionOffset + 28)], 16)
print('\n' + 'Models Section, Bones Offset is:')
print(hex(modelsSectionBonesOffset))

#Creating a variable for the offset to Models Section, Parts; based on ( modelsSectionOffset + 36 bytes of Models Section, Header, + (numberOfBones * 4) ).
modelsSectionPartsOffset = (modelsSectionOffset + 36 + (numberOfBones * 4))
print('\n' + 'Models Section, Parts offset is:')
print(hex(modelsSectionPartsOffset))

#Pulling offsets to individual bones from Models Section, Parts...
remainingParts = numberOfParts
individualBoneOffset = []
currentOffsetToBoneOffset = (modelsSectionPartsOffset + 0x19)

while remainingParts > 0:
	currentBoneOffset = c[(currentOffsetToBoneOffset)]
	currentBoneOffset = ''.join([c[(currentOffsetToBoneOffset)], c[(currentOffsetToBoneOffset - 1)]])
	individualBoneOffset.append(str(currentBoneOffset))
	
	currentOffsetToBoneOffset = (currentOffsetToBoneOffset + 0x20)
	
	remainingParts = remainingParts - 1

print('\n' + 'individualBoneOffset list equals:')
print(individualBoneOffset)


#Creating a variable for the offset to Models Section, Animations; based on Models Section, Parts offset + (number of parts * 32).
modelsSectionAnimationsOffset = (modelsSectionPartsOffset + (numberOfParts * 32))
print('\n' + 'Models Section, Animations offset is:')
print(hex(modelsSectionAnimationsOffset))

#Pulling offsets to individual animations from Models Section, Animations...
individualAnimationOffset = []
currentOffsetToAnimationOffset = (modelsSectionAnimationsOffset + 0xd)

remainingAnimations = (numberOfAnimations)

while remainingAnimations > 0:
	currentAnimationOffset = c[(currentOffsetToAnimationOffset)]
	currentAnimationOffset = ''.join([c[(currentOffsetToAnimationOffset)], c[(currentOffsetToAnimationOffset - 1)]])
	individualAnimationOffset.append(str(currentAnimationOffset))
	
	currentOffsetToAnimationOffset = (currentOffsetToAnimationOffset + 0x10)
	
	remainingAnimations = remainingAnimations - 1

print('\n' + 'individualAnimationOffset list equals:')
print(individualAnimationOffset)


#Extracting individual part data...
currentPartNumber = 0
nextPartNumber = 1

while (currentPartNumber < numberOfParts):
	if currentPartNumber == (numberOfParts - 1):
		currentPartOffset = individualBoneOffset[currentPartNumber]
		FO_Breakdown.write('Part ' + str(currentPartNumber) + ' [at offset 0x' + individualBoneOffset[currentPartNumber] + ']:\n' + '[code]\n')
		FO_Breakdown.write(' '.join(c[int(currentPartOffset, 16):int(individualAnimationOffset[0], 16)]) + '\n' + '[/code]\n\n\n')
		currentPartNumber = currentPartNumber + 1
	else:
		currentPartOffset = individualBoneOffset[currentPartNumber]
		nextPartOffset = individualBoneOffset[nextPartNumber]
		FO_Breakdown.write('Part ' + str(currentPartNumber) + ' [at offset 0x' + individualBoneOffset[currentPartNumber] + ']:\n' + '[code]\n')
		FO_Breakdown.write(' '.join(c[int(currentPartOffset, 16):int(nextPartOffset, 16)]) + '\n' + '[/code]\n\n\n')
		currentPartNumber = currentPartNumber + 1
		nextPartNumber = nextPartNumber + 1
		
FO_Breakdown.write('\n\n\n\n' + 'Note: Skeleton Data Section runs until Animation Data Section.')
FO_Breakdown.write('\n\n' + '______________________________________')

FO_Breakdown.write('\n\n\n\n' + 'Animation Data Section [at offset 0x')
FO_Breakdown.write(str(individualAnimationOffset[0]) + ']:' + '\n\n')
FO_Breakdown.write('Note: Offset to Animation Data Section contained in Models Section, Animation.' + '\n\n')
FO_Breakdown.write('Note2: Number of animations contained in Models Section, Header.' + '\n\n\n')


#Extracting individual animation data...
currentAnimationNumber = 0
nextAnimationNumber = 1

while (currentAnimationNumber < numberOfAnimations):
	if currentAnimationNumber == (numberOfAnimations - 1):
		currentAnimationOffset = individualAnimationOffset[currentAnimationNumber]
		FO_Breakdown.write('Animation ' + str(currentAnimationNumber) + ' [at offset 0x' + individualAnimationOffset[currentAnimationNumber] + ']:\n' + '[code]\n')
		FO_Breakdown.write(' '.join(c[int(currentAnimationOffset, 16):int(modelsSectionOffset)]) + '\n' + '[/code]\n\n\n')
		currentAnimationNumber = currentAnimationNumber + 1
	else:
		currentAnimationOffset = individualAnimationOffset[currentAnimationNumber]
		nextAnimationOffset = individualAnimationOffset[nextAnimationNumber]
		FO_Breakdown.write('Animation ' + str(currentAnimationNumber) + ' [at offset 0x' + individualAnimationOffset[currentAnimationNumber] + ']:\n' + '[code]\n')
		FO_Breakdown.write(' '.join(c[int(currentAnimationOffset, 16):int(nextAnimationOffset, 16)]) + '\n' + '[/code]\n\n\n')
		
		currentAnimationNumber = currentAnimationNumber + 1
		nextAnimationNumber = nextAnimationNumber + 1

FO_Breakdown.write('\n\n\n\n' + 'Note: Animation Data Section runs until Models Section.')
FO_Breakdown.write('\n\n' + '______________________________________')

FO_Breakdown.write('\n\n\n\n' + 'Models Section [at offset ' + str(hex(modelsSectionOffset)) + ']:' + '\n\n\n')

FO_Breakdown.write('Note: Offset to Models Section contained in BCX Header Section.' + '\n\n\n\n')


#Extracting Model Section, Header...
FO_Breakdown.write('Models Section, Header' + '\n\n' + '[code]' + '\n')

FO_Breakdown.write(' '.join(c[(modelsSectionOffset):(modelsSectionBonesOffset)]))
FO_Breakdown.write('\n' + '[/code]\n\n\n')
FO_Breakdown.write('Breakdown:' + '\n\n')


#Making a list of the Models Section Header, to use in its breakdown...
modelsSectionHeaderList = (c[(modelsSectionOffset):(modelsSectionBonesOffset)])

FO_Breakdown.write(str(modelsSectionHeaderList[0]) + ' ' + str(modelsSectionHeaderList[1]) + ' - Unknown' + '\n')
FO_Breakdown.write(str(modelsSectionHeaderList[2]) + ' - Number of bones' + '\n')
FO_Breakdown.write(str(modelsSectionHeaderList[3]) + ' - Number of parts' + '\n')
FO_Breakdown.write(str(modelsSectionHeaderList[4]) + ' - Number of animations' + '\n')
FO_Breakdown.write(' '.join(modelsSectionHeaderList[5:28]))
FO_Breakdown.write(' - Unknown' + '\n')
FO_Breakdown.write(' '.join(modelsSectionHeaderList[28:32]))
FO_Breakdown.write(' - Offset to Model Section, Bones [little-endian, so 0x')
FO_Breakdown.write( (modelsSectionHeaderList[31]) + (modelsSectionHeaderList[30]) + (modelsSectionHeaderList[29]) + (modelsSectionHeaderList[28]) + '\n' )
FO_Breakdown.write(' '.join(modelsSectionHeaderList[32:36]))
FO_Breakdown.write(' - Unknown' + '\n\n')
FO_Breakdown.write('\n' + 'Note: Models Section, Header runs until Models Section, Bones.' + '\n\n\n\n\n' + '______________________________________' + '\n\n\n\n')

FO_Breakdown.write('Models Section, Bones [at offset ' + str(hex(modelsSectionBonesOffset)) + ']:' + '\n\n\n')
FO_Breakdown.write('Note: Offset to Models Section, Bones contained in Models Section, Header.' + '\n\n')
FO_Breakdown.write('Note2: Number of bones contained in Models Section, Header.' + '\n\n')
FO_Breakdown.write('Note3: Bones are 4 bytes in size each.' + '\n\n\n\n' + '[code]' + '\n')



#Extracting Model Section, Bones...
currentModelSectionBoneNumber = 0

while (currentModelSectionBoneNumber < numberOfBones):
	if currentModelSectionBoneNumber == (numberOfBones - 1):
		currentModelSectionBoneOffset = modelsSectionBonesOffset + (currentModelSectionBoneNumber * 4)
		FO_Breakdown.write(' '.join(c[(currentModelSectionBoneOffset):(modelsSectionPartsOffset)]) + '\n')
		currentModelSectionBoneNumber = currentModelSectionBoneNumber + 1
	else:
		currentModelSectionBoneOffset = modelsSectionBonesOffset + (currentModelSectionBoneNumber * 4)
		nextModelSectionBoneOffset = (currentModelSectionBoneOffset + 4)
		FO_Breakdown.write(' '.join(c[(currentModelSectionBoneOffset):(nextModelSectionBoneOffset)]) + '\n')
		
		currentModelSectionBoneNumber = currentModelSectionBoneNumber + 1

FO_Breakdown.write('[/code]\n\n\n\n')
FO_Breakdown.write('Note: Models Section, Bones runs until Models Section, Parts.' + '\n\n' + '______________________________________' + '\n\n\n')


FO_Breakdown.write('Models Section, Parts [at offset ' + str(hex(modelsSectionPartsOffset)) + ']:' + '\n\n\n')
FO_Breakdown.write('Note: Offset to Models Section, Parts not contained in any known value; determined based on the end of Models Section, Bones.' + '\n\n')
FO_Breakdown.write('Note2: Number of parts contained in Models Section, Header.' + '\n\n')
FO_Breakdown.write('Note3: Parts are 32 bytes in size each.' + '\n\n\n\n' + '[code]' + '\n')


#Extracting Model Section, Parts...
currentModelSectionPartNumber = 0

while (currentModelSectionPartNumber < numberOfParts):
	if currentModelSectionPartNumber == (numberOfParts - 1):
		currentModelSectionPartOffset = modelsSectionPartsOffset + (currentModelSectionPartNumber * 32)
		FO_Breakdown.write(' '.join(c[(currentModelSectionPartOffset):(modelsSectionAnimationsOffset)]) + '\n')
		currentModelSectionPartNumber = currentModelSectionPartNumber + 1
	else:
		currentModelSectionPartOffset = modelsSectionPartsOffset + (currentModelSectionPartNumber * 32)
		nextModelSectionPartOffset = (currentModelSectionPartOffset + 32)
		FO_Breakdown.write(' '.join(c[(currentModelSectionPartOffset):(nextModelSectionPartOffset)]) + '\n')
		
		currentModelSectionPartNumber = currentModelSectionPartNumber + 1

FO_Breakdown.write('[/code]\n\n\n\n')

FO_Breakdown.write('Breakdown of first line of Models Section, Parts above:' + '\n\n')

#Making a list of the first part in Models Section, Parts, to use in its breakdown...
modelsSectionPartList = (c[(modelsSectionPartsOffset):(modelsSectionPartsOffset + 32)])


FO_Breakdown.write(str(modelsSectionPartList[0]) + ' - Unknown; "0 - not calculate stage lighting and color. 1 - calculate."' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[1]) + ' - Bone to which this part is attached to' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[2]) + ' - Number of vertices' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[3]) + ' - Number of Texture coord' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[4]) + ' - Number of textured quads (Gourad Shading)' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[5]) + ' - Number of textured triangles (Gourad Shading)' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[6]) + ' - Number of textured quads (Flat Shading)' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[7]) + ' - Number of textured triangles (Flat Shading)' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[8]) + ' - Number of monochrome triangles' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[9]) + ' - Number of monochrome quads' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[10]) + ' - Number of gradated triangles' + '\n')
FO_Breakdown.write(str(modelsSectionPartList[11]) + ' - Number of gradated quads' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[12:14]))
FO_Breakdown.write(' - number of data in block 4 (flags)' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[14:16]))
FO_Breakdown.write(' - Relative offset to ?' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[16:18]))
FO_Breakdown.write(' - Relative offset to ?' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[18:20]))
FO_Breakdown.write(' - Relative offset to texture settings. Indexed by 5th block data (control)' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[20:22]))
FO_Breakdown.write(' - Relative offset to one byte stream for every packet with texture' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[22:24]))
FO_Breakdown.write(' - Relative offset to ?' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[24:28]))
FO_Breakdown.write(' - Offset to skeleton data section (little-endian, so 0x')
FO_Breakdown.write(modelsSectionPartList[27] + modelsSectionPartList[26] + modelsSectionPartList[25] + modelsSectionPartList[24])
FO_Breakdown.write(')' + '\n')
FO_Breakdown.write(' '.join(modelsSectionPartList[28:32]))
FO_Breakdown.write(' - Offset to ?' + '\n\n\n\n\n\n')

FO_Breakdown.write('Note: Models Section, Parts runs until Models Section, Animations.' + '\n\n' + '______________________________________' + '\n\n\n')


FO_Breakdown.write('Models Section, Animations [at offset ' + str(hex(modelsSectionAnimationsOffset)) + ']:' + '\n\n\n')
FO_Breakdown.write('Note: Offset to Models Section, Animations not contained in any known value; determined based on the end of Models Section, Parts.' + '\n\n')
FO_Breakdown.write('Note2: Number of animations contained in Models Section, Header.' + '\n\n')
FO_Breakdown.write('Note3: Animations are 16 bytes in size each.' + '\n\n\n\n' + '[code]' + '\n')


#Extracting Model Section, Animations...
currentModelSectionAnimationNumber = 0

while (currentModelSectionAnimationNumber < numberOfAnimations):
	if currentModelSectionAnimationNumber == (numberOfAnimations - 1):
		currentModelSectionAnimationOffset = modelsSectionAnimationsOffset + (currentModelSectionAnimationNumber * 16)
		FO_Breakdown.write(' '.join(c[(currentModelSectionAnimationOffset):(fileSize + 1)]) + '\n')
		currentModelSectionAnimationNumber = currentModelSectionAnimationNumber + 1
	else:
		currentModelSectionAnimationOffset = modelsSectionAnimationsOffset + (currentModelSectionAnimationNumber * 16)
		nextModelSectionAnimationOffset = (currentModelSectionAnimationOffset + 16)
		FO_Breakdown.write(' '.join(c[(currentModelSectionAnimationOffset):(nextModelSectionAnimationOffset)]) + '\n')
		
		currentModelSectionAnimationNumber = currentModelSectionAnimationNumber + 1
		
		
FO_Breakdown.write('[/code]\n\n\n\n')

FO_Breakdown.write('Breakdown of first line of Models Section, Animations above:' + '\n\n')

#Making a list of the first animation in Models Section, Animations, to use in its breakdown...
modelsSectionAnimationList = (c[(modelsSectionAnimationsOffset):(modelsSectionAnimationsOffset + 16)])

FO_Breakdown.write(' '.join(modelsSectionAnimationList[0:2]))
FO_Breakdown.write(' - Number of frames (little-endian, so 0x')
FO_Breakdown.write(modelsSectionAnimationList[1] + modelsSectionAnimationList[0])
FO_Breakdown.write(')' + '\n')
FO_Breakdown.write(modelsSectionAnimationList[2] + ' - Number of bones' + '\n')
FO_Breakdown.write(modelsSectionAnimationList[3] + ' - Number of translation frames' + '\n')
FO_Breakdown.write(modelsSectionAnimationList[4] + ' - Number of static translation frames' + '\n')
FO_Breakdown.write(modelsSectionAnimationList[5] + ' - Number of rotation frames' + '\n')
FO_Breakdown.write(' '.join(modelsSectionAnimationList[6:8]))
FO_Breakdown.write(' - Relative offset to translation frames (little-endian, so 0x')
FO_Breakdown.write(modelsSectionAnimationList[7] + modelsSectionAnimationList[6])
FO_Breakdown.write(')' + '\n')
FO_Breakdown.write(' '.join(modelsSectionAnimationList[8:10]))
FO_Breakdown.write(' - Relative offset to static translation frames (little-endian, so 0x')
FO_Breakdown.write(modelsSectionAnimationList[9] + modelsSectionAnimationList[8])
FO_Breakdown.write(')' + '\n')
FO_Breakdown.write(' '.join(modelsSectionAnimationList[10:12]))
FO_Breakdown.write(' - Relative offset to rotation frames (little-endian, so 0x')
FO_Breakdown.write(modelsSectionAnimationList[11] + modelsSectionAnimationList[10])
FO_Breakdown.write(')' + '\n')
FO_Breakdown.write(' '.join(modelsSectionAnimationList[12:16]))
FO_Breakdown.write(' - Offset to animation data section (little-endian, so 0x')
FO_Breakdown.write(modelsSectionAnimationList[15] + modelsSectionAnimationList[14] + modelsSectionAnimationList[13] + modelsSectionAnimationList[12])
FO_Breakdown.write(')' + '\n\n\n\n\n\n')

FO_Breakdown.write('Note: Models Section, Animations runs until the end of the file.' + '\n\n\n')



#Add a test to output the pieces of the file in the correct sequence to recreate the entire file as a temp file, then checksum that with the original file, then delete the temp file?

#Add a test to confirm the input BCX is really a BCX?

print('\n' + 'BCX breakdown complete - see file Breakdown.txt for output.')

#Closing breakdown file handle...
FO_Breakdown.close()

